﻿Option Explicit On
Imports System.IO
Imports SB_PictureTagger.Stammbaum

Public Class Main
    '###################################################################################################################
    '############### Main ##############################################################################################
    '###################################################################################################################

    Private Sub Main_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Initial
        Settings.PictureTagger.Pub_oLoaded_TaggedIMG.Clear()
        LoadConfigForm()

    End Sub 'Main_Load

    Private Sub Form1_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        SaveTagg()
        SaveConfigForm()
    End Sub 'Form1_Closing


    '###################################################################################################################
    '############### Form1_Function-Tasks ##############################################################################
    '###################################################################################################################

    '###################################################################################################################
    '############### Form1_Sub-Tasks ###################################################################################
    '###################################################################################################################
    Private Sub Clear_Form()
        tb_Bild_Time.Clear()
        tb_Bild_Title.Clear()
        tb_Place_Addresse.Clear()
        tb_Place_GPS.Clear()
        rtb_Bild_Description.Clear()
        rtb_Place_Description.Clear()
    End Sub 'Resetet die Form

    Private Sub LoadConfigForm()
        'Unsterstützte Formate
        ReDim Settings.PictureTagger.pub_aSupportedFiles(5)
        Settings.PictureTagger.pub_aSupportedFiles(0) = ".jpg"
        Settings.PictureTagger.pub_aSupportedFiles(1) = ".bmp"
        Settings.PictureTagger.pub_aSupportedFiles(2) = ".gif"
        Settings.PictureTagger.pub_aSupportedFiles(3) = ".png"
        Settings.PictureTagger.pub_aSupportedFiles(4) = ".jp2"
        Settings.PictureTagger.pub_aSupportedFiles(5) = ".tif"
        'Portable oder Nicht komming soon!

    End Sub 'LoadConfigForm
    Private Sub SaveConfigForm()
        'Wird noch Programmert, stürzt sich auf Stammbaum.Settings
    End Sub

    Private Sub Reload()
        SaveTaggByEvent()
        Stammbaum.Module.PictureTagger.PT_LoadVerzeichnis()
        LoadTaggedIMG()
    End Sub 'Reload

    Private Sub SaveTaggByEvent()
        If Settings.PictureTagger.pub_bChangeTagg Then
            If Not System.IO.File.Exists(Settings.PictureTagger.Pub_oLoaded_TaggedIMG.Path) Then
                Settings.PictureTagger.pub_bChangeTagg = False
            ElseIf cb_AutoSave.Checked Then
                SaveTagg()
            ElseIf MessageBox.Show("Do you want to save changes?", "SB-PictureTagger", MessageBoxButtons.YesNo) = DialogResult.Yes Then
                SaveTagg()
            Else
                Settings.PictureTagger.pub_bChangeTagg = False
            End If
        End If
    End Sub 'SaveTaggByEvent Like: Next/Last Picture, Colse Form, ... 

    Private Sub SaveTagg()

        If Settings.PictureTagger.pub_aPfade(Settings.PictureTagger.pub_nPfadeIndex) <> "" Then

            'TextBox sichern
            Stammbaum.Settings.PictureTagger.Pub_oLoaded_TaggedIMG.Title = tb_Bild_Title.Text
            Stammbaum.Settings.PictureTagger.Pub_oLoaded_TaggedIMG.Time = tb_Bild_Time.Text
            Stammbaum.Settings.PictureTagger.Pub_oLoaded_TaggedIMG.Description = rtb_Bild_Description.Text

            Stammbaum.Settings.PictureTagger.Pub_oLoaded_TaggedIMG.Ort.Title = tb_Place_Title.Text
            Stammbaum.Settings.PictureTagger.Pub_oLoaded_TaggedIMG.Ort.Adresse = tb_Place_Addresse.Text
            Stammbaum.Settings.PictureTagger.Pub_oLoaded_TaggedIMG.Ort.GPS = tb_Place_GPS.Text
            Stammbaum.Settings.PictureTagger.Pub_oLoaded_TaggedIMG.Ort.Description = rtb_Place_Description.Text

            'Lese Markierungen <-- in Planung (Fieleicht Überflüsig, jenachdem wie Markierungen angesteuert werden

            Stammbaum.Module.PictureTagger.PT_SaveTaggedIMG()

        End If
        Settings.PictureTagger.pub_bChangeTagg = False
    End Sub 'SaveTagg to What ever is Configurated in Stammbaum.Module.PictureTagger

    Private Sub LoadTaggedIMG()
        
        SaveTaggByEvent()

        'Textvelder Lehren
        Clear_Form()

        'Lade neues TaggedIMG mit Stammbaum.Module.PictureTagger Modul
        Stammbaum.Module.PictureTagger.PT_LoadTaggedIMG()

        'Zeigt den BildPfad unter der PictureBox an
        Label7.Text = Settings.PictureTagger.Pub_oLoaded_TaggedIMG.Path

        'Befülle die TextBox-en
        tb_Bild_Title.Text = Settings.PictureTagger.Pub_oLoaded_TaggedIMG.Title
        tb_Bild_Time.Text = Settings.PictureTagger.Pub_oLoaded_TaggedIMG.Time
        rtb_Bild_Description.Text = Settings.PictureTagger.Pub_oLoaded_TaggedIMG.Description

        tb_Place_Title.Text = Settings.PictureTagger.Pub_oLoaded_TaggedIMG.Ort.Title
        tb_Place_Addresse.Text = Settings.PictureTagger.Pub_oLoaded_TaggedIMG.Ort.Adresse
        tb_Place_GPS.Text = Settings.PictureTagger.Pub_oLoaded_TaggedIMG.Ort.GPS
        rtb_Place_Description.Text = Settings.PictureTagger.Pub_oLoaded_TaggedIMG.Ort.Description

        'Erstelle Marks

    End Sub 'LoadTaggedIMG -> SaveTaggByEvent()

    '###################################################################################################################
    '############### Buton Events: Click ###############################################################################
    '###################################################################################################################


    Private Sub b_exit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles b_exit.Click
        ' Programm Beenden
        Me.Close()
    End Sub 'Cloas Programm

    Private Sub b_loaddir_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles b_loaddir.Click
        'Laden eines zu Taggenden Bilder-Verzeichnis
        Dim sTMP As String
        sTMP = Tools.Dialoge.FolderBrowserDialog()
        If Directory.Exists(sTMP) Then
            Settings.PictureTagger.Pub_sPath = sTMP
            Reload()
        End If
    End Sub 'Öffne Ordner -> wenn Pfad OK -> Reload()

    Private Sub b_reloaddir_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles b_reloaddir.Click
        Reload()
    End Sub 'Relaod()

    Private Sub b_save_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles b_save.Click
        If Settings.PictureTagger.pub_bChangeTagg Then
            SaveTagg()
        End If
    End Sub 'Wenn Änderung -> SaveTagg()

    Private Sub b_next_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles b_next.Click
        If Settings.PictureTagger.pub_nPfadeIndex < UBound(Settings.PictureTagger.pub_aPfade) Then
            Settings.PictureTagger.pub_nPfadeIndex += 1
            LoadTaggedIMG()
        End If
    End Sub 'Next Index -> LoadTaggedIMG()

    Private Sub b_last_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles b_last.Click
        If Settings.PictureTagger.pub_nPfadeIndex > 0 Then
            Settings.PictureTagger.pub_nPfadeIndex = Settings.PictureTagger.pub_nPfadeIndex - 1
            LoadTaggedIMG()
        End If
    End Sub 'Last Index -> LoadTaggedIMG()


    '###################################################################################################################
    '############### TextBox: TextCanched ##############################################################################
    '###################################################################################################################
    Private Sub rtb_Bild_Description_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles rtb_Bild_Description.TextChanged
        Settings.PictureTagger.pub_bChangeTagg = True
    End Sub 'Description Changed

    Private Sub rtb_Place_Description_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles rtb_Place_Description.TextChanged
        Settings.PictureTagger.pub_bChangeTagg = True
    End Sub 'Ort Descriptio Changed

    Private Sub tb_Bild_Time_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles tb_Bild_Time.TextChanged
        Settings.PictureTagger.pub_bChangeTagg = True
    End Sub 'Time Changed

    Private Sub tb_Bild_Title_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles tb_Bild_Title.TextChanged
        Settings.PictureTagger.pub_bChangeTagg = True
    End Sub 'Titel Changed

    Private Sub tb_Place_Title_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles tb_Place_Title.TextChanged
        Settings.PictureTagger.pub_bChangeTagg = True
    End Sub 'Ort Titel Changed

    Private Sub tb_Place_Addresse_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles tb_Place_Addresse.TextChanged
        Settings.PictureTagger.pub_bChangeTagg = True
    End Sub 'Ort Addresse Changed

    Private Sub tb_Place_GPS_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles tb_Place_GPS.TextChanged
        Settings.PictureTagger.pub_bChangeTagg = True
    End Sub 'Ort GPS Changed


    '###################################################################################################################
    '############### CheckBox Events: CheckStateChanged ################################################################
    '###################################################################################################################

    Private Sub cb_marks_visible_CheckStateChanged(ByVal sender As Object, ByVal e As System.EventArgs)
        'Wenn cb_marks_visible=true then ZeichneMarks() ELSE VerstekeMarks()
    End Sub 'Visible/Hide Markierungen

    '###################################################################################################################
    '############### NumericUpDown Events: ValueChanged ################################################################
    '###################################################################################################################

    Private Sub NumericUpDown_OrdnerTiefe_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles NumericUpDown_OrdnerTiefe.ValueChanged
        Settings.PictureTagger.nOrdnerTiefe = NumericUpDown_OrdnerTiefe.Value
    End Sub 'Ordner Tiefe Festlegen


End Class
